<?php

namespace Ems\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

use Ems\Services\IndicadoresSaudeTrabalhoService;

class IndicadoresSaudeTrabalhoController {
    /** @var IndicadoresSaudeTrabalhoService */
    protected $indicadoresSaudeTrabalhoService;

    public function __construct(
        IndicadoresSaudeTrabalhoService $indicadoresSaudeTrabalhoService
    ) {
        $this->indicadoresSaudeTrabalhoService = $indicadoresSaudeTrabalhoService;
    }

    public function getTotalAfastamentosPorCIDLegalOcupacao(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getRow();

            $totais = $this->indicadoresSaudeTrabalhoService->getTotalAfastamentosPorCIDLegalOcupacao($row);

            $response->addDataSet(new DataSet('data', $totais));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    
    public function getTotalAfastamentosPorCIDOcupacao(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getRow();
            
            $totais = $this->indicadoresSaudeTrabalhoService->getTotalAfastamentosPorCIDOcupacao($row);

            $response->addDataSet(new DataSet('data', $totais));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function getTotalAfastamentosPorNTEPLegalOcupacao(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getRow();

            $totais = $this->indicadoresSaudeTrabalhoService->getTotalAfastamentosPorNTEPLegalOcupacao($row);

            $response->addDataSet(new DataSet('data', $totais));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function getTotalAfastamentosPorNTEPOcupacao(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getRow();

            $totais = $this->indicadoresSaudeTrabalhoService->getTotalAfastamentosPorNTEPOcupacao($row);

            $response->addDataSet(new DataSet('data', $totais));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }   
}