<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoSubstituicao extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens      = $this->getItensAssociativeArray();
        $extraRow   = $this->getExtraRow();
        
        $nrorg      = Utils::getParamters()->getNrorg();
        $nrvinculom = $this->getSolicitacao()->getNrvinculom();
        $cdstatus   = $extraRow['CDSTATUS'] ?? null;
        
        $dataset = $itens;
        
        $dataset["update"] = false;
        $dataset["CDSTATUS"] = $cdstatus ?? 3;
        
        $this->adicionarUpdateProcesso($dataset);
    }
    
    public function rejeitar() {}
    
      public function adicionarUpdateProcesso($dataset) {
        $nrorg = Utils::getParamters()->getNrorg();
        $cdoperador = Utils::getParamters()->getCdoperador();
        $update = filter_var($dataset["update"], FILTER_VALIDATE_BOOLEAN);
        $cdoperadorsolicitacao = $this->getSolicitacao()->getCdoperinclusao();

        $nmoperador = '';

        if(empty($dataset["NMPROCESSO"])) {
          $operador = Utils::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(array('nrorg' => $nrorg,
          'cdoperador' => $cdoperadorsolicitacao));
  
          if($operador) {
            $nmoperador = $operador->getNmoperador();
          }
        }

        $dataset["IDPUBLICAVAGA"] = ($dataset["IDPUBLICAVAGA"] == 'Y' || $dataset["IDPUBLICAVAGA"] == 'S') ? 'S' : 'N';

        $idpublicavaga         = (isset($dataset["IDPUBLICAVAGA"]))         ? $dataset["IDPUBLICAVAGA"]         :  'N';
        $nrocupacaodesejada    = (isset($dataset["NROCUPACAOM"]))           ? $dataset["NROCUPACAOM"]           : null;
        $nrescalatrabm         = (isset($dataset["NRESCALATRABM"]))         ? $dataset["NRESCALATRABM"]         : null;
        $nrestrutgeren         = (isset($dataset["NRESTRUTGEREN"]))         ? $dataset["NRESTRUTGEREN"]         : null;
        $nrvagas               = (isset($dataset["NRVAGAS"]))               ? $dataset["NRVAGAS"]               : null;
        $idstatus              = (isset($dataset["CDSTATUS"]))              ? $dataset["CDSTATUS"]              : null;
        $dtlimsolicita         = (isset($dataset["DTLIMSOLICITA"]))         ? $dataset["DTLIMSOLICITA"]         : null;
        $dtsolicita            = (isset($dataset["DTSOLICITA"]))            ? $dataset["DTSOLICITA"]            : null;
        $nmprocesso            = (isset($dataset["NMPROCESSO"]))            ? $dataset["NMPROCESSO"]            : $nmoperador;
        $vrsalario             = (isset($dataset["VRSALARIO"]))             ? $dataset["VRSALARIO"]             : null;
        $nrtemplate            = (isset($dataset["NRTEMPLATE"]))            ? $dataset["NRTEMPLATE"]            : null;
        $nrtipoprocesso        = (isset($dataset["NRTIPOPROCESSO"]))        ? $dataset["NRTIPOPROCESSO"]        : null;
        $nrparcnegociosolicita = (isset($dataset["NRPARCNEGOCIOSOLICITA"])) ? $dataset["NRPARCNEGOCIOSOLICITA"] : null;
        $nrparcnegocioresp     = $nrparcnegociosolicita;
        $dsmotivo              = (isset($dataset["DSMOTIVO"]))              ? $dataset["DSMOTIVO"]              : null;
        $dsdescricao           = (isset($dataset["DSDESCRICAO"]))           ? $dataset["DSDESCRICAO"]           : null;
        $dslocalidade          = (isset($dataset["LOCALIDADE"]))            ? $dataset["LOCALIDADE"]            : null;
        $dtsuspensao           = (isset($dataset["DTSUSPENSAO"]))           ? $dataset["DTSUSPENSAO"]           : null;
        $dtcancelamento        = (isset($dataset["DTCANCELAMENTO"]))        ? $dataset["DTCANCELAMENTO"]        : null;
        $dtretorno             = (isset($dataset["DTRETORNO"]))             ? $dataset["DTRETORNO"]             : null;
        $nrprioridade          = (isset($dataset["NRPRIORIDADE"]))          ? $dataset["NRPRIORIDADE"]          : null;
        $dtconclusao           = (isset($dataset["DTCONCLUSAO"]))           ? $dataset["DTCONCLUSAO"]           : null;
        $dtprevistaadmissao    = (isset($dataset["DTPREVISTAADMISSAO"]))    ? $dataset["DTPREVISTAADMISSAO"]    : null;
        $nrtipovinculom        = (isset($dataset["NRTIPOVINCULOM"]))        ? $dataset["NRTIPOVINCULOM"]        : null;
        $nrvinculoempreg       = (isset($dataset["NRVINCULOEMPREG"]))       ? $dataset["NRVINCULOEMPREG"]       : null;
        $nrgrauinstr           = (isset($dataset["NRGRAUINSTR"]))           ? $dataset["NRGRAUINSTR"]           : null;
        $nrcpfpessoa           = (isset($dataset["NRCPFPESSOA"]))           ? $dataset["NRCPFPESSOA"]           : null;
        $nmpessoa              = (isset($dataset["NMPESSOA"]))              ? $dataset["NMPESSOA"]              : null;
        $nrvagasadmitidas = 0;


        Utils::getEntityManager()->beginTransaction();


        $dtlimsolicita = !empty($dtlimsolicita) ? DateUtil::getDataDeString($dtlimsolicita, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtsolicita = !empty($dtsolicita) ? DateUtil::getDataDeString($dtsolicita, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtsuspensao = !empty($dtsuspensao) ? DateUtil::getDataDeString($dtsuspensao, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtcancelamento = !empty($dtcancelamento) ? DateUtil::getDataDeString($dtcancelamento, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtretorno = !empty($dtretorno) ? DateUtil::getDataDeString($dtretorno, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtconclusao = !empty($dtconclusao) ? DateUtil::getDataDeString($dtconclusao, DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtprevistaadmissao = !empty($dtprevistaadmissao) ? DateUtil::getDataDeString($dtprevistaadmissao, DateUtil::FORMATO_BRASILEIRO, true) : null;
          
        if ($update) {
            $nrprocesso = $dataset["NRPROCESSO"];

            /** @var $processo \Folha\Entities\DesProcesso */
            $processo = Utils::getEntityManager()->getRepository('\Folha\Entities\DesProcesso')
                ->findOneBy(array('nrprocesso' => $nrprocesso,
                                       'nrorg' => $nrorg));


        } else {
            $nrprocesso = NovoCodigo::geraCodigo($nrorg, 'DES_PROCESSO', 1, 22, true);

            /** @var $processo \Folha\Entities\DesProcesso */
            $nrorginclusao = (isset($nrorg)) ? $nrorg : null;
            $dtinclusao = (isset($nrorg)) ? $nrorg : null;
            $nrorginclusao = (isset($nrorg)) ? $nrorg : null;
            $processo = new \Folha\Entities\DesProcesso();
            $processo->setNrprocesso($nrprocesso);
            $processo->setNrorg($nrorg);
            $processo->setDtinclusao(DateUtil::getDataAtual());
            $processo->setCdoperinclusao($cdoperador);
            $processo->setNrorginclusao($nrorg);
        }
        $processo->setIdpublicavaga($idpublicavaga);
        $processo->setNrocupacaodesejada($nrocupacaodesejada);
        $processo->setNrescalatrabm($nrescalatrabm);
        $processo->setNrestrutgeren($nrestrutgeren);
        $processo->setNrvagas($nrvagas);
        $processo->setidstatus($idstatus);
        $processo->setDtlimsolicita($dtlimsolicita);
        $processo->setDtsolicita($dtsolicita);
        $processo->setNmprocesso($nmprocesso);
        $processo->setVrsalario($vrsalario);
        $processo->setNrtemplate($nrtemplate);
        $processo->setNrtipoprocesso($nrtipoprocesso);
        $processo->setNrparcnegociosolicita($nrparcnegociosolicita);
        $processo->setNrparcnegocioresp($nrparcnegocioresp);
        $processo->setDsmotivo($dsmotivo);
        $processo->setDsdescricao($dsdescricao);
        $processo->setDslocalidade($dslocalidade);        
        $processo->setDtsuspensao($dtsuspensao);
        $processo->setDtcancelamento($dtcancelamento);
        $processo->setDtretorno($dtretorno);
        $processo->setNrprioridade($nrprioridade);
        $processo->setDtconclusao($dtconclusao);
        $processo->setDtprevistaadmissao($dtprevistaadmissao);
        $processo->setNrtipovinculom($nrtipovinculom);
        $processo->setNrvinculoempreg($nrvinculoempreg);
        $processo->setNrgrauinstr($nrgrauinstr);
        $processo->setNrcpfpessoa($nrcpfpessoa);
        $processo->setNmpessoa($nmpessoa);
        $processo->setNrvagasadmitidas($nrvagasadmitidas);
        $processo->setDtultatu(DateUtil::getDataAtual());
        $processo->setCdoperultatu($cdoperador);
        $processo->setNrorgultatu($nrorg);

        Utils::getEntityManager()->persist($processo);
        Utils::getEntityManager()->flush();
        Utils::getEntityManager()->commit();

        $this->insertItemNrProcesso(NovoCodigo::geraCodigo($nrorg, 'GPE_ITEMSOLICITACAO', 1, 12, true), $this->getSolicitacao()->getNrsolicitacao(), $nrorg, 'NRPROCESSO', 'Nr Processo', $nrprocesso, $cdoperador);
;

        if ($update)
            return 'update';
        else
            return 'save';

    }

    public  function insertItemNrProcesso($nritemsolicitacao, $nrsolicitacao, $nrorg, $dschaveitemsoli, $dslabelitemsoli, $dsvaloritemsoli, $cdoperador) {
      $sql = <<<SQL
          INSERT INTO GPE_ITEMSOLICITACAO (
              NRITEMSOLICITACAO, NRSOLICITACAO,    NRORG,
              DSCHAVEITEMSOLI,   DSLABELITEMSOLI, DSVALORITEMSOLI,
              DTINCLUSAO,        NRORGINCLUSAO,   CDOPERINCLUSAO, 
              CDOPERULTATU
          )
          VALUES (
              :NRITEMSOLICITACAO, :NRSOLICITACAO,   :NRORG,
              :DSCHAVEITEMSOLI,   :DSLABELITEMSOLI, :DSVALORITEMSOLI,
              SYSDATE,            :NRORG,           :CDOPERADOR, 
              :CDOPERADOR
          )
SQL;

      Utils::getEntityManager()->getConnection()->prepare($sql)
          ->execute(array(
              "NRITEMSOLICITACAO"  => $nritemsolicitacao,
              "NRSOLICITACAO"      => $nrsolicitacao,
              "NRORG"              => $nrorg,
              "DSCHAVEITEMSOLI"    => $dschaveitemsoli,
              "DSLABELITEMSOLI"    => $dslabelitemsoli,
              "DSVALORITEMSOLI"    => $dsvaloritemsoli,
              "CDOPERADOR"         => $cdoperador
          )
      );
  }

}
