<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Calculos\Geral\MemoriaCalculo;
use HCM\FPA\Entity\FpafaixatabelaEntity;
use HCM\FPA\Entity\FpatabelafolhaEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpaPtregraEntity;
use HCM\FPA\Entity\FpaValorreferenciamEntity;
use HCM\FPA\Entity\FpaParamfolhahEntity;

class IRRF {

    public static function calcula(
        $incidencia, $evento, $evento_base, $mes_competencia, $item_de_calculo,
        $assoc_evento, $eventom, $valor_referencia,
        $vinculo, $acumulaRecMinimo,$plr=false
    ) {
        $nr_dependentes = $vinculo->historico->getNrdependir();

        $vrDeducaoDependente = $valor_referencia->getValorReferencia(FpaValorreferenciamEntity::VR_DEDUCAO_DEP_IR);
        
        $deducao_dependente = $nr_dependentes * $vrDeducaoDependente;

        $nrevento =  $assoc_evento->retornaEvento(
            FpatipoassoceveEntity::ASSOC_DEDUCAO_DEPENDENTE, $vinculo->getNrorg()
        );
        $evento_deducao_dependente = $eventom->retornaEvento($nrevento);
        
        $item_de_calculo->geraEvento(
            $evento_deducao_dependente, null, $deducao_dependente, $nr_dependentes, 1
        );

        $base = $item_de_calculo->calculaIncidencias(
            $incidencia, $mes_competencia, $eventom
        );
        
        if ($base < 0) {
            $base = 0;
        }

        $nrevento =  $assoc_evento->retornaEvento($evento_base, $vinculo->getNrorg());
        $evento_base_irrf = $eventom->retornaEvento($nrevento);
        $calculoEvento = 'Valor = '.$base.' (Base)';
        MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_base_irrf,$calculoEvento,$mes_competencia,$base,0,null,$base,$incidencia,100);
        $item_de_calculo->geraEvento($evento_base_irrf, null, $base, 0, 1);
        $indice = $item_de_calculo->procuraEvento($evento_base_irrf, null);
        if ($indice !== -1) {
            $base = $item_de_calculo->retornaValor($indice);
        } else {
            $base = 0;
        }
        $referencia = 0;
        if($plr==true){
            $irrf = FpafaixatabelaEntity::retornaValorProcessado(
                $base, FpatabelafolhaEntity::TAB_IRRF_PLR, $mes_competencia, $referencia
            );
            if($base > 0){
                $referenciaIrrf = $irrf / $base * 100;
            }
            $calculoEvento = '('.$base.' * '.$referenciaIrrf.') / 100 = '.$irrf;
        }else {
            $irrf = FpafaixatabelaEntity::retornaValorProcessado(
                $base, FpatabelafolhaEntity::TAB_IRRF, $mes_competencia, $referencia
            );
            if($base > 0){
                $referenciaIrrf = $irrf / $base * 100;
            }
            $calculoEvento = '('.$base.' * '.$referenciaIrrf.') / 100 = '.$irrf;
        }
        $nrevento =  $assoc_evento->retornaEvento(
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_CALC, $vinculo->getNrorg()
        );
        $evento_irrf_descontado = $eventom->retornaEvento($nrevento);
        $posicao = $item_de_calculo->procuraEvento($evento_irrf_descontado);
        if ($posicao !== -1) {
            $irDescontado = $item_de_calculo->retornaValor($posicao);
            $calculoEvento .= PHP_EOL.$irrf.'(Irrf) - '.$irDescontado.'(Irrf Descontado)';
            $irrf -= $irDescontado;
        }

        $nrevento =  $assoc_evento->retornaEvento(FpaTipoassoceveEntity::ASSOC_IRRF_CALC_MES_ANTERIOR, $vinculo->getNrorg());
        $evento_mesAnterior = $eventom->retornaEvento($nrevento);
        $posicao = $item_de_calculo->procuraEvento($evento_mesAnterior, $mes_competencia);
        if ($posicao !== -1){
            $irrf_MesAnterior = $item_de_calculo->retornaValor($posicao);
            $calculoEvento .= PHP_EOL.$irrf.'(Irrf) + '.$irrf_MesAnterior.'(Irrf Mes Anterior)';
            $irrf += $irrf_MesAnterior;
            
        }
        
        $vrRecolhimentoMinimo = (float)$valor_referencia->getValorReferencia(FpaValorreferenciamEntity::VR_RECOLHIMENTO_MIN_IR);
        if ($irrf > $vrRecolhimentoMinimo) {
            $nrevento =  $assoc_evento->retornaEvento($evento, $vinculo->getNrorg());
            $evento_irrf = $eventom->retornaEvento($nrevento);
            MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_irrf,$calculoEvento,$mes_competencia,$irrf,$referencia,null,$base,$incidencia,100);
            $item_de_calculo->geraEvento($evento_irrf, null, $irrf, $referencia, 1);
        } else {
            if ($acumulaRecMinimo === FpaParamfolhahEntity::IDIRRFRECOLHMIN_SIM){
                $nrevento =  $assoc_evento->retornaEvento(FpaTipoassoceveEntity::ASSOC_IRRF_CALC_ACUMULADO, $vinculo->getNrorg());
                $evento_irrf_acumulado = $eventom->retornaEvento($nrevento);
                MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_irrf_acumulado,$calculoEvento,$mes_competencia,$irrf,$referencia,null,$base,$incidencia,100);
                $item_de_calculo->geraEvento($evento_irrf_acumulado, null, $irrf, null, 2);
            }else{
                $nrevento =  $assoc_evento->retornaEvento($evento, $vinculo->getNrorg());
                $evento_irrf = $eventom->retornaEvento($nrevento);
                MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_irrf,$calculoEvento,$mes_competencia,$irrf,$referencia,null,$base,$incidencia,100);
                $item_de_calculo->geraEvento($evento_irrf, null, $irrf, $referencia, 1);
            }
        }
    }
}