<?php

namespace HCM\FPA\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\Messages;
use HCM\FPA\Services\ImportacaoRemessaCcBbService;
use HCM\Util\HCMParameters;

class ImportacaoRemessaCcBbController extends crud{
    
     public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters, ImportacaoRemessaCcBbService $importacaoRemessaCcBbService){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        $this->importacaoRemessaCcBbService = $importacaoRemessaCcBbService;
        parent::__construct($dataSourceManager);
    }
    
    public function ImportacaoRemessaCcBb(DTO\Request\DataSet $request, DTO\Response $response){
        try {
            foreach ($request->getDataSet()->getRows() as $row) {
                $message = array();
                
                foreach ($row['DSPATH'] as $arquivo) {
                    $row['DSPATH'] = [$arquivo];
                    $message = array_merge($message, $this->importacaoRemessaCcBbService->ImportacaoRemessaCcBb($row));
                }
                
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getMessage', [$message]));
                $response->addNotification(new DTO\Response\Notification(Messages::HCM00001_GER_IMPORTACAO_SUCESS));
            }
        } catch (\Exception $e) {
            if ($e->getCode() === Messages::ALERT_MESSAGE_CODE) {
                $response->addMessage(new \Zeedhi\Framework\DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_WARNING));
            } elseif ($e->getCode() === Messages::ERROR_MESSAGE_CODE) {
                $response->addMessage(new \Zeedhi\Framework\DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
            } else {
                $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
    }
     
 
}