<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 11:14
 */

namespace HCM\VAB\Services;

use Zeedhi\Framework\HTTP\Kernel;
use HCM\VAB\IntegracaoVT\Controlador;
use HCM\Util\DateUtil;
use HCM\Geral\Services\FileService;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\Geral\Services\UploadFileService;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;



class IntegracaoValeTransporteService {

    protected $hcmParameters;

    public function __construct(Kernel $httpKernel,HCMParameters $hcmParameters,EntityManager $entitymanager, FPA $fpa, FileService $fileService,  UploadFileService $uploadsFileService) {
        $this->httpKernel = $httpKernel;
        $this->entityManager = $entitymanager;
        $this->hcmParameters = $hcmParameters;
        $this->fpa = $fpa;
        $this->fileService = $fileService;
        $this->uploadsFileService = $uploadsFileService;
    }

    public function importaIntegracao($nrorg, $dtmescompetencia, $row, $message) {
        try {
            $row['NRORG'] = $this->hcmParameters->getNrorgTrabalho(); 
            $row['NRPARCNEGOCIO'] = NULL; 
            $row['DSREFERENCIA'] = NULL; 
            $row['CDOPERINCLUSAO'] = NULL; 
            $row['IDFOTO'] = NULL; 
            $arquivo = $row['DSPATH'][0];
            
            
            $file = $this->httpKernel->factoryFromFileData($arquivo, FPA::getTempDirectory()."/teste");
                   
    
            if (!$file->isFile()) {
                throw new \Exception("Falha ao gravar o arquivo.");
            }
            
            $tipoIntegracao = null;
            if ($row['NMINTEGRACAO'] === 'importacao_otimo')
                $tipoIntegracao = Controlador::OTIMO;

            if ($row['NMINTEGRACAO'] === 'importacao_transfacil')
                $tipoIntegracao = Controlador::TRANSFACIL;
                
            if ($row['NMINTEGRACAO'] === 'importacao_direto')
                $tipoIntegracao = Controlador::DIRETO;    
                
            if ($row['NMINTEGRACAO'] === 'importacao_fetranspor')
                $tipoIntegracao = Controlador::FETRANSPOR; 

            $nrTipoLinhaVinculo = $tipoIntegracao == Controlador::FETRANSPOR && !empty($row['NRTIPOLINHAVINC']) ? $row['NRTIPOLINHAVINC'] : null;
            $dtIniIntegracao = DateUtil::getDataDeString($dtmescompetencia);
            $dtFimIntegracao = null;
            $dtmescompetencia = DateUtil::getDataDeString($dtmescompetencia,DateUtil::FORMATO_BRASILEIRO,true);
            $controlador = new Controlador($tipoIntegracao,$this->hcmParameters,$this->entityManager);
            $message = $controlador->executaIntegracao($nrorg, $dtmescompetencia, $file->getClientOriginalName(), $file->getPathname(), $dtIniIntegracao, $dtFimIntegracao, $message, $nrTipoLinhaVinculo);
            return $message;
        } catch (\Exception $e) {
            throw $e;
        }
    }

}
