/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOEDEIRO                                               */
/* Tabela : EQUIPAPROD                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 09/05/2006 - Arnaldo Coutinho Brito Junior                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MOEDEIRO
BEFORE INSERT OR UPDATE OR DELETE
ON MOEDEIRO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMOED := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOEDEIRO  ,  0) <> NVL(:NEW.CDMOEDEIRO  ,  0)) OR
         (NVL(:OLD.NMMOEDEIRO  ,  0) <> NVL(:NEW.NMMOEDEIRO  ,  0)) OR
         (NVL(:OLD.VRLIMINFMOED  ,0) <> NVL(:NEW.VRLIMINFMOED  ,0)) OR
         (NVL(:OLD.VRLIMSUPMOED,  0) <> NVL(:NEW.VRLIMSUPMOED,  0)) OR
         (NVL(:OLD.VRINTMOEDEIRO, 0) <> NVL(:NEW.VRINTMOEDEIRO ,0)) OR
         (NVL(:OLD.VRMINABAMOED  ,0) <> NVL(:NEW.VRMINABAMOED  ,0)) OR
         (NVL(:OLD.VRMAXABAMOED  ,0) <> NVL(:NEW.VRMAXABAMOED  ,0)) THEN
         :NEW.DTULTATUMOED := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOEDEIRO', '', 'CDMOEDEIRO='||:OLD.CDMOEDEIRO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOEDEIRO MODIFY DTULTATUMOED DEFAULT SYSDATE
/
