/*+
|                                               |
|     Trigger: DTULTATU_OPERAPROVSUPRI          |  
|     Tabela : OPERAPROVSUPRI                   |
|                                               |
|     Criao:                                  |
|     31/03/2009 - Leonardo Bispo               |
|                                               |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OPERAPROVSUPRI' and
            type = 'TR'                        and
            u.uid = o.uid                      and
            u.name = USER)
   DROP TRIGGER DTULTATU_OPERAPROVSUPRI
GO

CREATE TRIGGER DTULTATU_OPERAPROVSUPRI
ON OPERAPROVSUPRI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'OPERAPROVSUPRI',
                 'CDGERENTEAPROV='+CDGERENTEAPROV + ';CDFORNECED='+CDFORNECED +';',
                  GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OPERAPROVSUPRI
      SET DTULTATUOPAPROV = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(OPERAPROVSUPRI.CDFORNECED, 0)      = ISNULL(INSERTED.CDFORNECED, 0)) AND
            (ISNULL(OPERAPROVSUPRI.CDGERENTEAPROV, 0)  = ISNULL(INSERTED.CDGERENTEAPROV, 0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_OPERAPROVSUPRI','5.07.015';
GO
