CREATE TABLE OM_OQA_ASSUNTO (
  ID                NUMBER NOT NULL,   
  PAI_ID         	NUMBER NULL, 
  DSASSUNTO         VARCHAR2(100) NULL,
  NRORG             NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')         NOT NULL,
  IDATIVO           VARCHAR2(1)     DEFAULT 'S'                    NOT NULL,
  DTINCLUSAO        DATE            DEFAULT SYSDATE,
  DTULTATU          DATE            DEFAULT SYSDATE,
  NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
  CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1'                     NULL,
  NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
  CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
    CONSTRAINT CKC_IDATIVO_OM_OQA_ASSUNTO CHECK (IDATIVO IN ('S','N')),
    CONSTRAINT PK_ACL_OQA_NOVO PRIMARY KEY(ID),
    CONSTRAINT FK_OM_OQA_ASSUNTO_PAI FOREIGN KEY (PAI_ID) REFERENCES OM_OQA_ASSUNTO (ID) 
)
/

CREATE INDEX OM_OQA_ASSUNTO_PAI_FK ON OM_OQA_ASSUNTO (PAI_ID)
/

CREATE TABLE OM_OQA_ITEM(
  ID                   NUMBER    NOT NULL,   
  PRODUTO_ID           NUMBER    NOT NULL,
  PAI_ID               NUMBER    NULL,
  DSASSUNTO            VARCHAR2(100)  NULL,
  FILENAME             VARCHAR2(1000) NULL, 
  FILETYPE             VARCHAR2(100)  NULL, 
  FILESIZE             NUMBER(10)     NULL,
  FILELABEL            VARCHAR2(1000) NULL,
  ORDEM_ITEM           NUMBER NULL, 
  NRORG             NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')         NOT NULL,
  IDATIVO           VARCHAR2(1)     DEFAULT 'S'                    NOT NULL,
  DTINCLUSAO        DATE            DEFAULT SYSDATE,
  DTULTATU          DATE            DEFAULT SYSDATE,
  NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
  CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1'                     NULL,
  NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
  CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
    CONSTRAINT CKC_IDATIVO_OM_OQA_ITEM CHECK (IDATIVO IN ('S','N')),
    CONSTRAINT PK_ACL_OQA_ITEM PRIMARY KEY(ID),
    CONSTRAINT FK_OM_OQA_ITEM_PRODCT FOREIGN KEY (PRODUTO_ID) REFERENCES OM_PRODUTO(ID),
    CONSTRAINT FK_OM_OQA_ITEM_PAI FOREIGN KEY (PAI_ID) REFERENCES OM_OQA_ITEM (ID)
)
/
CREATE INDEX OM_OQA_ITEM_PRODCT_FK ON OM_OQA_ITEM (PRODUTO_ID)
/
CREATE INDEX OM_OQA_ITEM_PAI_FK ON OM_OQA_ITEM (PAI_ID)
/

CREATE TABLE OM_OQA_ITEM_ASSUNTO(
    ID              NUMBER NOT NULL,
    ITEM_ID         NUMBER NOT NULL,
    ASSUNTO_ID      NUMBER NOT NULL,
    NRORG             NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')         NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'                    NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1'                     NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')        NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',  
        CONSTRAINT CKC_IDATIVO_OM_OQA_IT_ASSUNT CHECK (IDATIVO IN ('S','N')),
        CONSTRAINT PK_OM_OQA_ITEM_ASSUNTO PRIMARY KEY (ID),
        CONSTRAINT FK_OM_OQA_ITEM_ASSUNTO_ITEM FOREIGN KEY (ITEM_ID) REFERENCES OM_OQA_ITEM (ID),
        CONSTRAINT FK_OM_OQA_ITEM_ASSUNTO_ASSUNT FOREIGN KEY (ASSUNTO_ID) REFERENCES OM_OQA_ASSUNTO (ID)
)
/
CREATE INDEX OM_OQA_ITEM_ASSUNTO_ITEM_FK ON OM_OQA_ITEM_ASSUNTO (ITEM_ID)
/

CREATE INDEX OM_OQA_ITEM_ASSUNTO_ASSUNT_FK ON OM_OQA_ITEM_ASSUNTO (ASSUNTO_ID)
/